import java.io.*;

import java.util.*;


public class Banque {
  Vector liste_de_compte;

  Banque() {
    liste_de_compte = new Vector();
  }

  public Compte getCompte(int numero) {
    for (int i = 0; i < liste_de_compte.size(); i++) {
      Compte c = (Compte) liste_de_compte.get(i);
      if (c.identifiant_client == numero) {
        return c;
      }
    }
    return null;
  }

  public Compte ajouteCompteEpargne(String id, int numero, double montant) {
    try {
      Compte c = new Compte_epargne(id, numero, montant);
      liste_de_compte.add(c);
      return c;
    } catch (MyExceptionCompte e) {
      System.out.println("ajout d'un compte pargne: " + e.getMessage() + "pour le compte \n" + e.aProbleme);
      return null;
    }
  }

  public Compte ajouteCompteCourant(String id, int numero, double montant) {
    try {
      Compte c = new Compte_courant(id, numero, montant);
      liste_de_compte.add(c);
      return c;
    } catch (MyExceptionCompte e) {
      System.out.println("ajout d'un compte courant: " + e.getMessage() + "pour le compte \n" + e.aProbleme);
      return null;
    }
  }

  public void supprimer_un_compte(Compte C) {
    liste_de_compte.remove(C);
  }

  public void afficher_compte() {
    System.out.println("----------------------------");
    for (int i = 0; i < liste_de_compte.size(); i++) {
      System.out.println(((Compte) liste_de_compte.elementAt(i)).toString());
      System.out.println("----------------------------");
    }
  }

  public static void main(String[] args) throws IOException {
    Banque sogenerale = new Banque();

    //on fixe la somme minimale pour le Compte pargne:
    Compte_epargne.fixe_somme_minimale(100);
    System.out.println("*************");
    System.out.println("cration des comptes");
    System.out.println("*************");
    sogenerale.ajouteCompteEpargne("Andr", 1, 150);
    sogenerale.ajouteCompteCourant("Bernard", 2, 250);
    sogenerale.ajouteCompteCourant("Charles", 3, 25);
    //Une exception va tre leve.
    sogenerale.ajouteCompteEpargne("Daniel", 4, 2);
    System.out.println("*************");
    System.out.println("affichage des comptes");
    System.out.println("*************");
    sogenerale.afficher_compte();

    //On affiche les comptes qui se trouvent dans la banque.
    sogenerale.afficher_compte();




    System.out.println("*************");
    System.out.println("tentative de retrait");
    System.out.println("*************");

    Compte c = sogenerale.getCompte(3);
    try {
      c.retrait("01/10/2004",110); //Une exception va tre leve.
    } catch (MyExceptionCompte e) {
      System.out.print("erreur retrait pour le compte:" + e.aProbleme + "  \n" + e.getMessage());
    }



    Compte c1 = sogenerale.getCompte(1);
    try{
    c1.deposer("2004/01/10",1000);
    c1.retrait("2004/01/10",100);
    c1.deposer("2004/01/15",395);
    c1.retrait("2004/02/15",10);
    c1.deposer("2004/02/25",1000);

    }catch(MyExceptionCompte e){
      System.out.print(e.getMessage()+" "+e.aProbleme);
    }

    java.io.FileOutputStream of= new java.io.FileOutputStream("compte1.dat");
    java.io.DataOutputStream od = new java.io.DataOutputStream(of);
    c1.write(od);

    System.out.println(c1);


  }
}
